﻿using Android.App;
using Android.OS;
using Android.Support.V7.App;
using Android.Runtime;
using Android.Widget;
using Android.Content;
using Android.Support.V4.App;

namespace App10
{
    [Activity(Label = "@string/app_name", Theme = "@style/AppTheme", MainLauncher = true)]
    public class MainActivity : AppCompatActivity
    {
        public static int MYTaskId=0;
        string CHANNEL_ID = "1111011";
        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.activity_main);
            CreateNotificationChannel();
            Button button1 = FindViewById<Button>(Resource.Id.button1);
            button1.Click += Button1_Click;

            Button button2 = FindViewById<Button>(Resource.Id.button2);
            button2.Click += Button2_Click;


            //Intent Myintent = PackageManager.GetLaunchIntentForPackage("com.companyname.app10");

            //Myintent.AddFlags(ActivityFlags.ClearTop);
            //StartActivity(Myintent);
            MYTaskId = TaskId;
        }

        private void Button2_Click(object sender, System.EventArgs e)
        {
            var intent = new Intent(this, typeof(Activity1));
            StartActivity(intent);
        }

        private void Button1_Click(object sender, System.EventArgs e)
        {
            //ActivityManager的moveTaskToFront(rti.id, ActivityManager.MOVE_TASK_WITH_HOME);方法将应用唤起到前台，

            //ActivityManager activityManager = GetSystemService(Context.ActivityService) as ActivityManager;
           // activityManager.MoveTaskToFront(TaskId, MoveTaskFlags.WithHome);

            // var intent = new Intent(Intent.ActionMain);
         //   Intent intent = PackageManager.GetLaunchIntentForPackage("com.companyname.app10");
            Intent intent = new Intent(this,typeof(NotificationClickReceiver));
           // intent.SetFlags(ActivityFlags.NewTask | ActivityFlags.ResetTaskIfNeeded );
            //Flag indicating that this PendingIntent can be used only once.
            var pendingIntent = PendingIntent.GetBroadcast(this, 0
                                                         , intent, 0);

            NotificationCompat.Builder builder = new NotificationCompat.Builder(this, CHANNEL_ID)
               .SetContentTitle("Sample Notification")
               .SetContentText("Hello World! This is my first notification!")
               .SetSmallIcon(Resource.Drawable.ic_notification).SetContentIntent(pendingIntent);

            // Build the notification:
            Notification notification = builder.Build();

            // Get the notification manager:
            NotificationManager notificationManager =
                GetSystemService(Context.NotificationService) as NotificationManager;

            // Publish the notification:
            const int notificationId = 0;
            notificationManager.Notify(notificationId, notification);
        }

        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }

        void CreateNotificationChannel()
        {
            if (Build.VERSION.SdkInt < BuildVersionCodes.O)
            {
                // Notification channels are new in API 26 (and not a part of the
                // support library). There is no need to create a notification
                // channel on older versions of Android.
                return;
            }

            var channelName = Resources.GetString(Resource.String.channel_name);
            var channelDescription = GetString(Resource.String.channel_description);
            var channel = new NotificationChannel(CHANNEL_ID, channelName, NotificationImportance.Default)
            {
                Description = channelDescription
            };

            var notificationManager = (NotificationManager)GetSystemService(NotificationService);
            notificationManager.CreateNotificationChannel(channel);
        }
    }
}